const { Middleware } = require('libflitter')

class PermissionMiddleware extends Middleware {
    async test(req, res, next, { check }) {
        if ( !req.user.can(check) )
            return res.status(401)
                .message('Insufficient permissions.')
                .api()

        return next()
    }
}

module.exports = exports = PermissionMiddleware
