const auth_routes = {
    prefix: '/api/v1/auth',

    middleware: [

    ],

    get: {
        '/mfa/enable/date': ['middleware::auth:UserOnly', 'controller::api:v1:Auth.get_mfa_enable_date'],

        '/roles': [
            ['middleware::api:Permission', { check: 'v1:auth:roles:list' }],
            'controller::api:v1:Auth.get_roles',
        ],
        '/users': [
            ['middleware::api:Permission', { check: 'v1:auth:users:list' }],
            'controller::api:v1:Auth.get_users',
        ],
    },

    post: {
        '/validate/username': ['controller::api:v1:Auth.validate_username'],
        '/attempt': [ 'controller::api:v1:Auth.attempt' ],
        '/mfa/generate': ['middleware::auth:UserOnly', 'controller::api:v1:Auth.generate_mfa_key'],
        '/mfa/attempt': ['middleware::auth:DMZOnly', 'controller::api:v1:Auth.attempt_mfa'],
        '/mfa/enable': [
            'middleware::auth:UserOnly',
            ['middleware::auth:RequireTrust', { scope: 'mfa.enable', deplete: true }],
            'controller::api:v1:Auth.enable_mfa'
        ],
        '/mfa/disable': [
            'middleware::auth:UserOnly',
            ['middleware::auth:RequireTrust', { scope: 'mfa.disable', deplete: true }],
            'controller::api:v1:Auth.disable_mfa',
        ],
    },
}

module.exports = exports = auth_routes
