const password_routes = {
    prefix: '/api/v1/password',

    middleware: [
        'auth:UserOnly',
    ],

    get: {
        '/resets': ['controller::api:v1:Password.get_resets'],
        '/app_passwords': ['controller::api:v1:Password.get_app_passwords'],
    },

    post: {
        '/app_passwords': ['controller::api:v1:Password.create_app_password'],
        '/resets': [
            ['middleware::auth:RequireTrust', { scope: 'password.reset' }],
            'controller::api:v1:Password.reset_password',
        ],
    },

    delete: {
        '/app_passwords/:uuid': ['controller::api:v1:Password.delete_app_password'],
    }
}

module.exports = exports = password_routes
